/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>

#include "sx12.h"

int main()
{
        int vhan, fhan, length;
	char buffer[32768];
	int rlen = 0;

	if((vhan = open("/dev/sx12a",O_WRONLY)) <= 0)
	{
		printf("Error opening driver.\n");
		return EXIT_FAILURE;
	}
	
	if((fhan = open("test.mpg",O_RDONLY)) <= 0)
	{
		printf("Error opening MPEG input file.\n");
		close(vhan);
                return EXIT_FAILURE;
	}
	
	printf("Press CTRL-C or pull any DIO to ground to terminate.\n");

	length = read(fhan, buffer, sizeof(buffer));

	while(ioctl(vhan, X12_IOC_READ_GPIO) == 0)
	{
		printf("Video queue:%d\n", ioctl(vhan, X12_IOC_GET_VQSIZE));
        	write(fhan, buffer, length);

		rlen += write(vhan, &buffer[rlen], length - rlen);

		if(rlen == length)
		{
			rlen = 0;
			if((length = read(fhan, buffer, sizeof(buffer))) <= 0)
				break;
		}
	}	

	close(vhan);
	close(fhan);

  	return EXIT_SUCCESS;
}
